'Compilable Example:
#Compiler PBWin 10
#Compile Exe "gbinstancemanager.exe"
#Dim All
#Debug Error On
#Debug Display On
%Unicode = 1
#Include "Win32API.inc"
#Resource Icon, logo "images\logo.ico"
#Resource Icon, xhelp "images\help.ico"
#Resource Icon, xsettings "images\settings.ico"

Enum Equates Singular
   Ask                 = 500
   AutoOpenNewInstance
   AutoSwitchToExisting
   IDC_Toolbar
   IDT_Settings
   IDT_Help
   IDM_Ask
   IDM_AutoOpen
   IDM_AutoSwitch
   IDM_CloseAll
   IDM_CloseAllOthers
   IDM_Sep
   IDM_NewInstance
   IDM_MaxInstanceCount
   IDM_TimeStamp
End Enum

$ver = "v1.01"
$CustomMsg = "InstanceSettings"
%UniqueNumber = 1818181818
%DefaultMaxInstanceCount = 5

Global hDlg,hToolbar,hSettings,hImageList,hMsg,ghHook,hLastActive As Dword, StartTime$
Global InstanceCount, MaxInstanceCount,InstanceSetting,TimeStamp As Long   'INI settings

Function PBMain() As Long
   If AllowNewInstance = 0 Then Exit Function  '<---- dialog ends there is appropriate
   Dialog New Pixels, 0, "gbInstanceManager  " + $ver ,300,300,300,100, %WS_OverlappedWindow To hDlg
   If TimeStamp Then Dialog Set Text hDlg, "gbInstanceManager  " + $ver + "     " + StartTime$
   SetWindowLong(hDlg, %GWL_USERDATA, %UniqueNumber)  '<---- LONG allows up to 10 digits
   Dialog Set Icon hDlg, "logo"
   CreateToolbar
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local nmtb As TBNotify Ptr, rc As Rect, w,h,iResult As Long, temp$
   Select Case Cb.Msg
      Case %WM_InitDialog
         StartTime$ = Time$
         hMsg = RegisterWindowMessage($CustomMsg)
         Settings_INI "get"
         SetMenuStatus

      Case %WM_Move
         Settings_INI "save"

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDM_TimeStamp
               TimeStamp = TimeStamp Xor 1
               PostMessage %hWnd_BroadCast, hMsg, 3, TimeStamp  'sync all dialogs
               SetMenuStatus : SaveInstanceSettings
            Case %IDM_Ask
               InstanceSetting = %Ask
               PostMessage %hWnd_BroadCast, hMsg, 2, InstanceSetting  'sync all dialogs
               SetMenuStatus : SaveInstanceSettings
            Case %IDM_AutoOpen
               InstanceSetting = %AutoOpenNewInstance
               PostMessage %hWnd_BroadCast, hMsg, 2, InstanceSetting  'sync all dialogs
               SetMenuStatus : SaveInstanceSettings
            Case %IDM_AutoSwitch
               InstanceSetting = %AutoSwitchToExisting
               PostMessage %hWnd_BroadCast, hMsg, 2, InstanceSetting  'sync all dialogs
               SetMenuStatus : SaveInstanceSettings
            Case %IDM_CloseAll
               PostMessage %hWnd_BroadCast, hMsg, 0, 0      'close all dialogs
            Case %IDM_CloseAllOthers
               PostMessage %hWnd_BroadCast, hMsg, 0, hDlg   'close all other dialogs
               Dialog Set Text hDlg, "gbInstanceManager  " + $ver
               Sleep 1000  'give time for others to close
               Settings_INI "save"
            Case %IDT_Settings, %IDM_NewInstance
               Settings_INI "save"
               iResult = Shell(Exe.Full$)
            Case %IDM_MaxInstanceCount
               Dialog Get Loc hDlg To w,h
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProcExt), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = InputBox$("", "Max Instance Count", Str$(MaxInstanceCount),w+40,h+150)
               If Len(temp$) Then
                  MaxInstanceCount = Val(temp$)
                  SaveInstanceSettings
                  SetMenuStatus
                  PostMessage %hWnd_BroadCast, hMsg, 1, MaxInstanceCount  'sync all dialogs
               End If
            Case %IDT_Help
                 temp$ = "http://www.garybeene.com/sw/gbinstancemanager.htm"
                 iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

         End Select

      Case hMsg
         '0,hWin     hWin is the sending instance
         '1,n        n is maxinstancecount
         '2,n        n is instance setting   %Ask, %AutoOpenNewInstance, or %AutoSwitchToExisting
         '3,n        n is value of TimeStamp (0 or 1)
         Select Case Cb.WParam
            Case 0    : If hDlg <> Cb.LParam Then Dialog End hDlg
            Case 1    : MaxInstanceCount = Cb.LParam
            Case 2    : InstanceSetting = Cb.LParam  : SetMenuStatus
            Case 3    : TimeStamp = Cb.LParam        : SetMenuStatus
         End Select

      Case %WM_Notify
         nmtb = Cb.LParam
         Select Case @nmtb.hdr.Code
            Case %TBN_DROPDOWN
               Select Case @nmtb.iItem
                  Case %IDT_Settings
                     Menu Set Text hSettings, ByCmd %IDM_MaxInstanceCount, "Set Max Instance Count   ("  + LTrim$(Str$(MaxInstanceCount)) + ")"
                     Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                     Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                     Call TrackPopupMenu (hSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
               End Select
         End Select

      Case %WM_Destroy
         Settings_INI "save"

   End Select
End Function

Sub CreateToolbar
   ImageList New Icon 24,24,24,20 To hImageList
   ImageList Add Icon hImageList, "xsettings"    '1
   ImageList Add Icon hImageList, "xhelp"        '2
   Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Flat Or %WS_Child
   Control Handle hDlg, %IDC_Toolbar To hToolbar
   SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS
   Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0    'attach imagelist
   Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Settings"
   Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Help,  %TbStyle_Button, "Help"

   Menu New PopUp To hSettings
   Menu Add String, hSettings, "Ask",  %IDM_Ask,  %MF_Enabled
   Menu Add String, hSettings, "AutoOpen",  %IDM_AutoOpen,  %MF_Enabled
   Menu Add String, hSettings, "AutoSwitch",  %IDM_AutoSwitch,  %MF_Enabled
   Menu Add String, hSettings, "-",  %IDM_Sep, %MF_Enabled
   Menu Add String, hSettings, "Display TimeStamps",  %IDM_TimeStamp,  %MF_Enabled
   Menu Add String, hSettings, "-",  %IDM_Sep, %MF_Enabled
   Menu Add String, hSettings, "Close All",  %IDM_CloseAll,  %MF_Enabled
   Menu Add String, hSettings, "Close All Others",  %IDM_CloseAllOthers,  %MF_Enabled
   Menu Add String, hSettings, "-",  %IDM_Sep, %MF_Enabled
   Menu Add String, hSettings, "Open New Instance",  %IDM_NewInstance,  %MF_Enabled
   Menu Add String, hSettings, "Set MaxInstance Count",  %IDM_MaxInstanceCount,  %MF_Enabled
End Sub

Sub SetMenuStatus

    Dialog Set Text hDlg, "gbInstanceManager  " + $ver + IIf$(TimeStamp, Space$(5)+StartTime$,"")

    Menu Set State hSettings, ByCmd %IDM_TimeStamp, TimeStamp * %MFS_Checked Or %MFS_Enabled

    Menu Set State hSettings, ByCmd %IDM_Ask, 0
    Menu Set State hSettings, ByCmd %IDM_AutoOpen, 0
    Menu Set State hSettings, ByCmd %IDM_AutoSwitch, 0
    Select Case InstanceSetting
       Case %Ask                   : Menu Set State hSettings, ByCmd %IDM_Ask, %MFS_Checked Or %MFS_Enabled
       Case %AutoOpenNewInstance   : Menu Set State hSettings, ByCmd %IDM_AutoOpen, %MFS_Checked Or %MFS_Enabled
       Case %AutoSwitchToExisting  : Menu Set State hSettings, ByCmd %IDM_AutoSwitch, %MFS_Checked Or %MFS_Enabled
    End Select
End Sub

Sub GetInstanceSettings
   Local temp, INIFileName As WStringZ * %Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   Getprivateprofilestring "All", "InstanceSetting", Str$(%AutoOpenNewInstance), temp, %Max_Path, INIFileName : InstanceSetting = Val(temp)
   Getprivateprofilestring "All", "MaxInstanceCount", Str$(%DefaultMaxInstanceCount), temp, %Max_Path, INIFileName : MaxInstanceCount = Val(temp)
   Getprivateprofilestring "All", "TimeStamp", "1", temp, %Max_Path, INIFileName : TimeStamp = Val(temp)
End Sub

Sub SaveInstanceSettings
   Local INIFileName As WStringZ * %Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   WritePrivateProfileString "All", "InstanceSetting", (Str$(InstanceSetting)), INIFileName
   WritePrivateProfileString "All", "MaxInstanceCount", (Str$(MaxInstanceCount)), INIFileName
   WritePrivateProfileString "All", "TimeStamp", (Str$(TimeStamp)), INIFileName
End Sub

Function AllowNewInstance() As Long
   Local hTry,hMostRecent,hProcess,PID As Dword, UniqueName As WStringZ * %Max_Path
   Local CreationTime, ExitTime, KernelTime, UserTime, MostRecentFT As FileTime

   GetInstanceSettings   '<--- get INI setting values
   UniqueName = "gbInstanceManager"                     '

   If CreateMutex(ByVal %Null, 0, UniqueName) = 0 Or GetLastError = %ERROR_ALREADY_EXISTS Then
     'get the most recent matching instance, limit # instances
      hTry = GeTTopWindow(%HWND_Desktop)
      Do While hTry
         If GetWindowLong(hTry, %GWL_UserData) = %UniqueNumber Then
           Incr InstanceCount
           If InstanceCount >= MaxInstanceCount Then
              ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
              MsgBox "No more instances allowed.", %MB_Ok + %MB_IconInformation, "Open New Instance"
              Beep : Function = 0 : Exit Function  '<--- # instances exceeds max count
           End If
           'get hWin creation time
           GetWindowThreadProcessID(hTry,PID)
           hProcess = OpenProcess(%Process_Query_Information Or %Process_VM_Read, %False, PID)
           If hProcess Then
               GetProcessTimes(hProcess, CreationTime, ExitTime, KernelTime, UserTime)
               If CompareFileTime(CreationTime, MostRecentFT) = 1 Then
                  MostRecentFT = CreationTime
                  hMostRecent = hTry   'later, focus will be given to this instance
               End If
           End If
        End If
        hTry = GetWindow(hTry, %GW_HWNDNEXT)
      Loop

      'decide what to do
      Select Case InstanceSetting   'ask, autoopen, autoswitch
         Case %Ask
            ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
            If MsgBox ("gbInstance already open. Open new instance?", %MB_OkCancel + _
                   %MB_IconInformation, "Previous Instance Check") = %IdCancel Then
               Function = 0
            Else
               Function = 1  'InstanceCount  '<---- allow new instance
            End If

         Case %AutoOpenNewInstance
            Function = 1     'InstanceCount   '<----  allow new instance

         Case %AutoSwitchToExisting
            ShowWindow(hMostRecent, %SW_Restore)
            ShowWindow(hMostRecent, %SW_Show)
            SetForegroundWindow(hMostRecent)
            Function = 0
      End Select
   Else
      Function = -1
   End If
End Function

Sub Settings_INI(Task$)
   Local x As Long, y As Long, xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"

   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      If InstanceCount Then
         Dialog Set Loc hDlg, Val(xResult) + 50, Val(yResult) + 50   'left/top
      Else
         Dialog Set Loc hDlg, Val(xResult), Val(yResult) 'left/top
      End If

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "375", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "125", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height
   End If
   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
   End If
End Sub


Function InputBoxProcExt(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
'      If UCase$(szTemp) = "BUTTON" Then @cst.cx = @cst20                           'prompt
      If UCase$(szTemp) = "BUTTON" Then @cst.x = 75                           'ok and cancel
      If UCase$(szTemp) = "STATIC" Then @cst.y = -50 : @cst.cx = 0  : @cst.cy = 20           'prompt
      If UCase$(szTemp) = "EDIT"   Then @cst.cx = 50 : @cst.y = @cst.y - 140  'textbox
      If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style)
      If UCase$(szTemp) = "#32770" Then @cst.cx = 175 : @cst.cy = @cst.cy - 130                'dialog
   End If
End Function

Function SBProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local pt As Point
   GetCursorPos pt
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, pt.x+25, pt.y+25, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx ghHook
   End If
End Function
